/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   fractal_samples.c                                  :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/25 14:52:57 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/25 14:52:58 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

void	julia_samples(t_fractol *fr, double real, double img)
{
	complex_equal(real, img, &fr->frac->com_const);
	new_and_clear_image(fr);
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
}

void	mandelbrot_samples(t_fractol *fr, double x, double y)
{
	fr->frac->mov.x = x;
	fr->frac->mov.y = y;
	fr->frac->mov.z = 1;
	new_and_clear_image(fr);
	parallel_fractal(fr);
	mlx_put_image_to_window(fr->mlx, fr->win, fr->img->ptr, 0, 0);
}
