/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   julia.c                                            :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: gtertysh <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2017/03/24 19:34:44 by gtertysh          #+#    #+#             */
/*   Updated: 2017/03/24 19:34:46 by gtertysh         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "fractol.h"

int		complex_jul(t_complex new, t_complex com_const, t_frac_data *data)
{
	int			i;
	t_complex	old;

	i = 0;
	while (i < data->max_itr)
	{
		old = new;
		new.rl = old.rl * old.rl - old.im * old.im + com_const.rl;
		new.im = 2 * old.rl * old.im + com_const.im;
		if ((new.rl * new.rl + new.im * new.im) > 4)
			break ;
		i++;
	}
	return (i);
}

t_color	julia(t_frac_data *ju, int x, int y)
{
	t_complex	new;
	int			i;

	new.rl = 1.5 * (x - WIDTH / 2) / (0.5 * ju->mov.z * WIDTH) + ju->mov.x;
	new.im = (y - HEIGHT / 2) / (0.5 * ju->mov.z * HEIGHT) + ju->mov.y;
	i = complex_jul(new, ju->com_const, ju);
	return (gradient((float)i / ju->max_itr, ju->grd));
}
